"use strict";

var _interopRequireWildcard = require("@babel/runtime-corejs2/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime-corejs2/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _toConsumableArray2 = _interopRequireDefault(require("@babel/runtime-corejs2/helpers/toConsumableArray"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime-corejs2/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime-corejs2/helpers/createClass"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime-corejs2/helpers/possibleConstructorReturn"));

var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime-corejs2/helpers/getPrototypeOf"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime-corejs2/helpers/inherits"));

var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime-corejs2/helpers/assertThisInitialized"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime-corejs2/helpers/defineProperty"));

var _react = _interopRequireWildcard(require("react"));

var _styledComponents = _interopRequireDefault(require("styled-components"));

var BlockEl = _styledComponents.default.span`
  width: 35px;
  height: 35px;
  box-sizing: border-box;
  border: 1px solid #000;
  display: flex;
  justify-content: center;
  align-items: center;
  @keyframes flash {
    from,
    50%,
    to {
      opacity: 1;
    }
    25%,
    75% {
      opacity: 0;
    }
  }
  &::before {
    content: '';
    display: ${function (props) {
  return props.current ? 'block' : 'none';
}};
    height: 15px;
    width: 1px;
    background: rgb(0, 0, 0);
    margin-left: 2px;
    animation: flash 2s infinite both;
  }
`;
var BlockElWrap = _styledComponents.default.div`
  display: flex;
  justify-content: space-around;
  align-items: center;
`;
var Input = _styledComponents.default.input`
  width: 0;
  height: 0;
  opacity: 0.1;
  position: absolute;
  z-index: -1;
`;
var BlockInputWrap = _styledComponents.default.div`
  position: relative;
`;

var BlockInput =
/*#__PURE__*/
function (_Component) {
  (0, _inherits2.default)(BlockInput, _Component);

  function BlockInput(props) {
    var _this;

    (0, _classCallCheck2.default)(this, BlockInput);
    _this = (0, _possibleConstructorReturn2.default)(this, (0, _getPrototypeOf2.default)(BlockInput).call(this, props));
    (0, _defineProperty2.default)((0, _assertThisInitialized2.default)((0, _assertThisInitialized2.default)(_this)), "state", void 0);
    (0, _defineProperty2.default)((0, _assertThisInitialized2.default)((0, _assertThisInitialized2.default)(_this)), "input", void 0);
    (0, _defineProperty2.default)((0, _assertThisInitialized2.default)((0, _assertThisInitialized2.default)(_this)), "defaultValues", void 0);
    var _props$length = props.length,
        length = _props$length === void 0 ? 6 : _props$length,
        _props$placeholder = props.placeholder,
        placeholder = _props$placeholder === void 0 ? '' : _props$placeholder;
    _this.defaultValues = Array(length).fill(placeholder);
    _this.state = {
      values: _this.defaultValues,
      input: '',
      curIndex: 0,
      focused: false,
      length
    };
    _this.onChange = _this.onChange.bind((0, _assertThisInitialized2.default)((0, _assertThisInitialized2.default)(_this)));
    _this.inputFocus = _this.inputFocus.bind((0, _assertThisInitialized2.default)((0, _assertThisInitialized2.default)(_this)));
    _this.onBlur = _this.onBlur.bind((0, _assertThisInitialized2.default)((0, _assertThisInitialized2.default)(_this)));
    return _this;
  }

  (0, _createClass2.default)(BlockInput, [{
    key: "onChange",
    value: function onChange(e) {
      var length = this.state.length;
      var _this$props = this.props,
          mask = _this$props.mask,
          onChange = _this$props.onChange;
      var input = e.target.value;
      var values = input.split('');

      if (values.length > length) {
        return;
      }

      var newStateValues = values.reduce(function (old, cur, index) {
        old[index] = mask || cur;
        return old;
      }, (0, _toConsumableArray2.default)(this.defaultValues));
      this.setState({
        input,
        curIndex: values.length,
        values: newStateValues
      }, function () {
        if (onChange) {
          onChange(input);
        }
      });
    }
  }, {
    key: "inputFocus",
    value: function inputFocus() {
      var _this2 = this;

      this.input.focus();
      this.setState({
        focused: true
      }, function () {
        var onFocus = _this2.props.onFocus;

        if (onFocus) {
          onFocus();
        }
      });
    }
  }, {
    key: "onBlur",
    value: function onBlur() {
      var _this3 = this;

      this.setState({
        focused: false
      }, function () {
        var onBlur = _this3.props.onBlur;

        if (onBlur) {
          onBlur();
        }
      });
    }
  }, {
    key: "render",
    value: function render() {
      var _this4 = this;

      var _this$state = this.state,
          values = _this$state.values,
          input = _this$state.input,
          curIndex = _this$state.curIndex,
          focused = _this$state.focused;
      var className = this.props.className;
      return _react.default.createElement(BlockInputWrap, {
        className: className
      }, _react.default.createElement(Input, {
        ref: function ref(el) {
          _this4.input = el;
        },
        value: input,
        type: "text",
        onChange: this.onChange,
        onBlur: this.onBlur
      }), _react.default.createElement(BlockElWrap, {
        onClick: this.inputFocus
      }, values.map(function (v, k) {
        return _react.default.createElement(BlockEl, {
          key: k,
          current: curIndex === k && focused
        }, v);
      })));
    }
  }]);
  return BlockInput;
}(_react.Component);

var _default = BlockInput;
exports.default = _default;